#ifndef __GFXOBJ_H_INCLUDED
#define __GFXOBJ_H_INCLUDED

#include "wintype.h"

/* type definition for a graphics destructor */
typedef void (*GFX_DTOR)(PVOID obj);

/* A graphics object in memory always starts with this. */
typedef struct tagGFXOBJECT {
  UINT32 sig;                 /* signature so we know what something is */
  UINT32 size;                /* size of total allocated memory in block */
  INT32 refcnt;               /* reference count */
  GFX_DTOR dtor;              /* destructor function called when we're no longer needed */
  struct tagGFXOBJECT *next;  /* support double linked lists of obejcts */
  struct tagGFXOBJECT *prev;
} GFXOBJECT, *PGFXOBJECT;

extern void _Go_init(PGFXOBJECT obj, UINT32 sig, UINT32 size);
extern void Go_unchain(PGFXOBJECT obj);
extern INT32 Go_addref(PGFXOBJECT obj);
extern INT32 Go_release(PGFXOBJECT obj);

#endif /* __GFXOBJ_H_INCLUDED */
